---
title: "Maintainers"
slug: "maintainers"
excerpt: "What Pants maintainers do and how to become one."
hidden: false
createdAt: "2020-05-16T22:36:48.659Z"
updatedAt: "2022-05-26T22:13:54.279Z"
---
The Pants community has several Maintainers: people with a proven track record of contributions to the community and an ongoing commitment to the project, who guide the contributions of the wider community.

Maintainer responsibilities
---------------------------

It is the responsibility of a maintainer to uphold the health and quality of the project.

- Maintainers are responsible for the quality of the contributions they approve.
- Maintainers should raise objections to changes that may impact the performance, security, or maintainability of the project.
- Maintainers should help shepherd changes through our contribution process.
- Maintainers should maintain a courteous and professional demeanor when participating in the community.
- Maintainers should be regular participants on our public communications channels.

> 📘 Releases
> 
> Pants publishes at least one new dev or stable release a week. A subset of the Maintainers takes responsibility for publishing these releases.
> 
> We use a [Google Calendar](https://calendar.google.com/calendar/b/0/embed?src=hvd8qnf6fnp5klnk7u46q1noeo@group.calendar.google.com&ctz=America/Los_Angeles) to coordinate who is on release duty in a given week. When it is time for a release, the Maintainer who has release duty that week is responsible for updating the release documentation, creating release builds, and shepherding them through the review and [release process](doc:release-process).

Becoming a maintainer
---------------------

Maintainer candidates are nominated by existing maintainers from among the wider contributor base. Criteria for nomination include:

- The candidate's desire to become a maintainer.
- A track record of good contributions.
- A friendly, helpful, positive attitude.

If a contributor has been nominated, and is willing to become a maintainer, then their candidacy will be discussed and voted on by the existing maintainers.

Maintainer onboarding
---------------------

New maintainers should be:

- Added:
  - to the [Maintainers Github team](https://github.com/orgs/pantsbuild/teams/maintainers)
  - to the [pants-maintainers@ Google Group](https://groups.google.com/g/pants-maintainers)
  - to [`MAINTAINERS.md`](https://github.com/pantsbuild/pants/blob/main/MAINTAINERS.md)
  - to the [Slack #maintainers-confidential room](doc:getting-help#slack)
  - to the [Meet the Team page](doc:team), with their proudest contribution
- Welcomed:
  - on the [pants-devel@ Google Group](https://groups.google.com/g/pants-devel)
  - in the [Slack #announce room](doc:getting-help#slack)
  - by [@pantsbuild on Twitter](https://twitter.com/pantsbuild)

Contributor onboarding
----------------------

New Contributors should be:

- Added:
  - to the [Contributors Github team](https://github.com/orgs/pantsbuild/teams/contributors)
  - to the [Meet the Team page](doc:team), with their proudest contribution
- Welcomed:
  - on the [pants-devel@ Google Group](https://groups.google.com/g/pants-devel)
  - in the [Slack #announce room](doc:getting-help#slack)
  - by [@pantsbuild on Twitter](https://twitter.com/pantsbuild)
