# 2.15.x Release Series

## 2.15.0.dev3 (Oct 03, 2022)

### New Features

* Add `venv_site_packages_copies` field to `pex_binary` ([#17046](https://github.com/pantsbuild/pants/pull/17046))

* Add golangci-lint to go backend ([#16994](https://github.com/pantsbuild/pants/pull/16994))

* go: add `go-generate` goal to run `go generate` on a package ([#16909](https://github.com/pantsbuild/pants/pull/16909))

* Support Java codegen for the OpenAPI backend ([#16862](https://github.com/pantsbuild/pants/pull/16862))

* go: render coverage reports as HTML ([#16995](https://github.com/pantsbuild/pants/pull/16995))

* Environment-aware subsystems ([#16965](https://github.com/pantsbuild/pants/pull/16965))

* Environment sensitive options ([#16840](https://github.com/pantsbuild/pants/pull/16840))

* Add retries to NetDownload intrinsic. ([#16798](https://github.com/pantsbuild/pants/pull/16798))

* go: add basic support for cgo ([#16413](https://github.com/pantsbuild/pants/pull/16413))

* Add support for add-trailing-comma tool ([#16776](https://github.com/pantsbuild/pants/pull/16776))

### User API Changes

* Upgrade Pex to 2.1.107. ([#17081](https://github.com/pantsbuild/pants/pull/17081))

* Restore the deprecated `filter` goal indefinitely ([#17027](https://github.com/pantsbuild/pants/pull/17027))

### Plugin API Changes

* Improve usability of the `--engine-visualize-to` option ([#17080](https://github.com/pantsbuild/pants/pull/17080))

* Change `fmt` plugin schema to allow for targetless formatters ([#16980](https://github.com/pantsbuild/pants/pull/16980))

* Renames `SubsystemRule()` to `Subsystem.rules()` ([#16954](https://github.com/pantsbuild/pants/pull/16954))

* Introduce new schema for lint plugins ([#16735](https://github.com/pantsbuild/pants/pull/16735))

* `Environment`, `EnvironmentRequest`, and `CompleteEnvironment` now include `Vars` in the name ([#16851](https://github.com/pantsbuild/pants/pull/16851))

* `MockGet` expects `input_types` kwarg, not `input_type` ([#16839](https://github.com/pantsbuild/pants/pull/16839))

### Bug fixes

* Fix dirtying of uncacheable nodes ([#17079](https://github.com/pantsbuild/pants/pull/17079))

* Make interpreter path expansion cache-correct ([#17051](https://github.com/pantsbuild/pants/pull/17051))

* Add python 3.10 to acceptable GCF runtimes ([#17028](https://github.com/pantsbuild/pants/pull/17028))

* Don't cache VCS version outside the current pants session. ([#17017](https://github.com/pantsbuild/pants/pull/17017))

* Fix Pantsd not properly invalidating when `CPPFLAGS` and `LDFLAGS` change ([#17009](https://github.com/pantsbuild/pants/pull/17009))

* Add `parametrize()` support for `__defaults__`. ([#16977](https://github.com/pantsbuild/pants/pull/16977))

* go: prepend $GOROOT/bin to PATH for tests ([#16993](https://github.com/pantsbuild/pants/pull/16993))

* Fix for hang with redirected stdio. ([#16970](https://github.com/pantsbuild/pants/pull/16970))

* Fix invalid field error message for parametrized fields. ([#16911](https://github.com/pantsbuild/pants/pull/16911))

* Fix venv re-population race. ([#16931](https://github.com/pantsbuild/pants/pull/16931))

* `wait` for killed nailgun processes. ([#16924](https://github.com/pantsbuild/pants/pull/16924))

* remove override of register_plugin_field ([#16919](https://github.com/pantsbuild/pants/pull/16919))

* Only request source roots for PEP-517 deps that belong on the syspath ([#16903](https://github.com/pantsbuild/pants/pull/16903))

* Upgrade `javaparser`, and use a permissive language level to support parsing more code ([#16896](https://github.com/pantsbuild/pants/pull/16896))

* docker: upgrade bollard crate for bug fix ([#16850](https://github.com/pantsbuild/pants/pull/16850))

* Preserve stdio when a local process times out. ([#16841](https://github.com/pantsbuild/pants/pull/16841))

### Performance

* Add an optional speculation delay when using a remote cache ([#16922](https://github.com/pantsbuild/pants/pull/16922))

* Only use remote cache when cache scope is Always or Successful ([#16920](https://github.com/pantsbuild/pants/pull/16920))

### Documentation

* Fix Helm K8S parser help message ([#17091](https://github.com/pantsbuild/pants/pull/17091))

* Update `pytest-xdist` docs. ([#17071](https://github.com/pantsbuild/pants/pull/17071))

* Fix the [python-bootstrap].search_path option name in the docs. ([#17063](https://github.com/pantsbuild/pants/pull/17063))

* Add Doron Somech's proudest contribution ([#17029](https://github.com/pantsbuild/pants/pull/17029))

* improve remote cache logging for hit or miss ([#16975](https://github.com/pantsbuild/pants/pull/16975))

* Remove bad linebreaks from python-run-goal page. ([#16976](https://github.com/pantsbuild/pants/pull/16976))

* Update changelog on docsite with 2.13, 2.14 links ([#16918](https://github.com/pantsbuild/pants/pull/16918))

* Add Marcelo to team page, move Josh Reed to Maintainer ([#16826](https://github.com/pantsbuild/pants/pull/16826))

* Don't mention a specific version in the manual install instructions. ([#16888](https://github.com/pantsbuild/pants/pull/16888))

## 2.15.0.dev2 (Sep 09, 2022)

### New Features

* Force colors from mypy always, strip in pants when --no-colors ([#16586](https://github.com/pantsbuild/pants/pull/16586))

* Add OpenAPI backend ([#16199](https://github.com/pantsbuild/pants/pull/16199))

* go: analyze imports paths by module to enable multiple `go_mod` targets ([#16386](https://github.com/pantsbuild/pants/pull/16386))

### Bug fixes

* docker: capture output once after container exits ([#16783](https://github.com/pantsbuild/pants/pull/16783))

* docker: lazily initialize docker connection ([#16779](https://github.com/pantsbuild/pants/pull/16779))

### Documentation

* Add IBM, Coinbase, and Astranis case studies ([#16805](https://github.com/pantsbuild/pants/pull/16805))

* Fix broken shortlinks that invoked "docs:" instead of "doc:" ([#16804](https://github.com/pantsbuild/pants/pull/16804))

* Add Brand24 to user list. ([#16793](https://github.com/pantsbuild/pants/pull/16793))

## 2.15.0.dev1 (Sep 04, 2022)

### New Features

* go: support placing resource files in packages (and not just embedding) ([#16688](https://github.com/pantsbuild/pants/pull/16688))

* "naive" docker command runner ([#16670](https://github.com/pantsbuild/pants/pull/16670))

* Adds `binary_name` field to PyOxidizer support ([#16696](https://github.com/pantsbuild/pants/pull/16696))

### Plugin API Changes

* The environment to use becomes a context-specific parameter ([#16721](https://github.com/pantsbuild/pants/pull/16721))

* Deprecate `Platform.current` in favor of requesting an injected `Platform` ([#16765](https://github.com/pantsbuild/pants/pull/16765))

* Allow `@union`s to declare additional types which are provided to implementers ([#16717](https://github.com/pantsbuild/pants/pull/16717))

* Deprecate remote_auth_plugin option - plugins can use entry points now. ([#16691](https://github.com/pantsbuild/pants/pull/16691))

### Bug fixes

* Add support for inferring dependencies used in type context bounds ([#16709](https://github.com/pantsbuild/pants/pull/16709))

* Resolve properly provided symbol names for types defined at top level package ([#16690](https://github.com/pantsbuild/pants/pull/16690))

* Include type bound constraints in consumed symbols during Scala inference ([#16692](https://github.com/pantsbuild/pants/pull/16692))

* Make experimental_shell_command deterministic ([#16675](https://github.com/pantsbuild/pants/pull/16675))

### Documentation

* List commercial Pants services that optionally supplement community's extensive free tier ([#16706](https://github.com/pantsbuild/pants/pull/16706))

* In python resource example, use importlib.resources to read assets ([#16695](https://github.com/pantsbuild/pants/pull/16695))

* Welcome community members to consider joining team ([#16681](https://github.com/pantsbuild/pants/pull/16681))

## 2.15.0.dev0 (Aug 29, 2022)

### New Features

* Add support for string interpolation in Helm deployments ([#16611](https://github.com/pantsbuild/pants/pull/16611))

* Add --squash and --pull options support for docker build ([#16607](https://github.com/pantsbuild/pants/pull/16607))

* Support Pex's `--path-mapping` with lockfiles for better local requirement support ([#16584](https://github.com/pantsbuild/pants/pull/16584))

* [experimental] adds `pants_oxidized_experimental` target, creating a standalone binary distribution for Pants ([#16484](https://github.com/pantsbuild/pants/pull/16484))

### User API Changes

* Remove deprecated `[python].only_binary`, `[python].no_binary`, and `[python].tailor_ignore_solitary_init_files` ([#16638](https://github.com/pantsbuild/pants/pull/16638))

* Remove deprecated `[python].lockfile_generator` and deprecate `poetry` subsystem (used previously for lockfile generation) ([#16633](https://github.com/pantsbuild/pants/pull/16633))

* Remove deprecated `use_deprecated_directory_cli_args_semantics` option ([#16630](https://github.com/pantsbuild/pants/pull/16630))

### Plugin API Changes

* Add support for passing multiple input params to a `@rule` `Get` ([#16668](https://github.com/pantsbuild/pants/pull/16668))

* Remove deprecated `matches_filespec` and `get_git` functions ([#16629](https://github.com/pantsbuild/pants/pull/16629))

* Remove unnecessary type parameter from `Get` ([#16634](https://github.com/pantsbuild/pants/pull/16634))

### Bug fixes

* Fix dirtying of uncacheable nodes ([#17079](https://github.com/pantsbuild/pants/pull/17079))

* Make `FilespecMatcher` case-sensitive ([#16673](https://github.com/pantsbuild/pants/pull/16673))

* Ensure the sandbox distdir exists when creating dists via PEP517. ([#16647](https://github.com/pantsbuild/pants/pull/16647))

### Performance

* Implement a batched local lookup for missing fingerprints. ([#16627](https://github.com/pantsbuild/pants/pull/16627))

* Optimize `CreateDigest` implementation. ([#16617](https://github.com/pantsbuild/pants/pull/16617))

### Documentation

* Create page of Pants team members and proudest contribs ([#16676](https://github.com/pantsbuild/pants/pull/16676))

* Fix example BSP groups file. ([#16649](https://github.com/pantsbuild/pants/pull/16649))

* Clarify wording for `--skip` options ([#16622](https://github.com/pantsbuild/pants/pull/16622))

* Fix `./pants help` docs on command line specs ([#16616](https://github.com/pantsbuild/pants/pull/16616))

* Mention team meetings as a Contributor permission ([#16543](https://github.com/pantsbuild/pants/pull/16543))
